import java.util.PriorityQueue;

public class AllocationManager {

	// a block node consists of a name, a starting address, a size, and a pointer to the next block (null if no next)
    public static class BlockNode {
        private String name;
        private int blockStart;
        private int blockSize;
        private BlockNode next;

        private BlockNode() { }; // can only construct inside AllocationManager
        private BlockNode(String name) {
			this.name = name;
		}

        public int size() {
			return blockSize + (next == null ? 0 : next.size());
		}

        public String toString() {
			String s = "["+name+", "+blockStart+"--"+(blockStart+blockSize-1)+"]";
			if (next != null) s += next.toString();
			return s;
		}
    }

	// a free space node consists of a starting address and a size
    private static class FreeSpaceNode implements Comparable { // can only be accessed inside AllocationManager
        int holeStart;
        int holeSize;

        FreeSpaceNode(int start, int size) {
			holeStart = start; holeSize = size;
		}

		public String toString() {
			return "{"+holeStart+"--"+(holeStart+holeSize-1)+"}";
		}

        public int compareTo(Object other) {
//			throw new UnsupportedOperationException();
		}
    }

	private static int MAX = 1000000000; // size of space
    private PriorityQueue<FreeSpaceNode> freeSpace; // free holes sorted by start
    private int numFiles; // update this variable in get/release
    private int numFragments; // update this variable in get/release
    private int totalFreeSpace; // update this variable in get/release for part 6

	public AllocationManager() {
		freeSpace = new PriorityQueue();
		freeSpace.add(new FreeSpaceNode(0,MAX)); // one giant hole
		totalFreeSpace = MAX;
	}

	// if size is nonpositive, do nothing.
	// otherwise, return a chain of blocks whose sizes add up to size.
	// the blocks must be from the first available free holes.
	// if two blocks occupy adjacent contiguous space, they should be merged into one.
	// assume that it will always be possible to make an allocation, until you're doing part 6.
    public BlockNode get(String name, int size) {
//		throw new UnsupportedOperationException();
	}

    public void release(BlockNode b) {
//		throw new UnsupportedOperationException();
	}

	// return the number of files currently allocated (got but not released yet),
	// e.g. the number of calls to get with positive size
	public int numFiles() {
//		throw new UnsupportedOperationException();
	}

	// return the number of fragments currently allocated (got but not released yet),
	// e.g. the total number of BlockNodes currently allocated
	public int numFragments() {
//		throw new UnsupportedOperationException();
	}
}
