public class AllocationManagerDemo {

    public static void main(String[] args) {
		// this sequence should test most situations but not necessarily all
		// e.g. it does not test multiple contiguous free spaces that need to be merged
		// and it does not test the case where if an allocation is possible
		AllocationManager am = new AllocationManager();
		AllocationManager.BlockNode b1 = am.get("A",1100);
		AllocationManager.BlockNode b2 = am.get("B",1200);
		AllocationManager.BlockNode b3 = am.get("C",1300);
		AllocationManager.BlockNode b4 = am.get("D",1400);
		AllocationManager.BlockNode b5 = am.get("E",800);
		AllocationManager.BlockNode b6 = am.get("F",900);
		System.out.println(b1); // prints [A, 0--1099]
		System.out.println(b2); // prints [B, 1100--2299]
		System.out.println(b3); // prints [C, 2300--3599]
		System.out.println(b4); // prints [D,3600--4999]
		System.out.println(b5); // prints [E, 5000-5799]
		System.out.println(b6); // prints [F, 5800--6699]
		am.release(b4);
		am.release(b2);
		System.out.println("numFiles: "+am.numFiles()+"; numFragments: "+am.numFragments()); // 4 files, 4 fragments
		AllocationManager.BlockNode b7 = am.get("G",700);
		AllocationManager.BlockNode b8 = am.get("H",1200);
		System.out.println(b7); // prints [G, 1100--1799]
		System.out.println(b8); // prints [H, 1800--2299][H, 3600--4299]
		if (b8.size()!=1200) throw new RuntimeException("bug, chained blocks add up to wrong size, "+b8.size()+"+ vs. 1200");
		am.release(b5);
		AllocationManager.BlockNode b9 = am.get("I",1300);
		System.out.println(b9); // prints [I, 4300--5599]    (two free blocks got merged here)
		if (b9.size()!=1300) throw new RuntimeException("bug, chained blocks add up to wrong size, "+b9.size()+"+ vs. 1300");
		am.release(b7);
		AllocationManager.BlockNode b10 = am.get("J",9000);
		System.out.println(b10); // prints [J, 1100--1799][J, 5600--5799][J, 6700--14799]
		if (b10.size()!=9000) throw new RuntimeException("bug, chained blocks add up to wrong size, "+b10.size()+"+ vs. 9000");
		System.out.println("numFiles: "+am.numFiles()+"; numFragments: "+am.numFragments()); // 6 files, 9 fragments
		am.release(b8);
		System.out.println("numFiles: "+am.numFiles()+"; numFragments: "+am.numFragments()); // 5 files, 7 fragments
	}

}
